//#####################################################################
// Copyright 2009, Nipun Kwatra.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Geometry_Particles/GEOMETRY_PARTICLES.h>
#include <Core/Particles/PARTICLES.h>
#include <Core/Vectors/VECTOR.h>
namespace PhysBAM{
//#####################################################################
// Constructor
//#####################################################################
template<class TV> GEOMETRY_PARTICLES<TV>::
GEOMETRY_PARTICLES()
    :X(0,0),V(0,0),store_velocity(false)
{
    Add_Array("X",&X);
}
//#####################################################################
// Constructor
//#####################################################################
template<class TV> GEOMETRY_PARTICLES<TV>::
GEOMETRY_PARTICLES(const GEOMETRY_PARTICLES& p)
    :PARTICLES<TV>()
{
    Add_Array("X",&X);
    Store_Velocity(p.store_velocity);
    this->Initialize(p);
}
//#####################################################################
// Destructor 
//#####################################################################
template<class TV> GEOMETRY_PARTICLES<TV>::
~GEOMETRY_PARTICLES()
{}
//#####################################################################
// Function Store_Velocity
//#####################################################################
template<class TV> void GEOMETRY_PARTICLES<TV>::
Store_Velocity(bool store)
{
    store_velocity=store;
    if(store) Add_Array("V",&V);
    else Remove_Array("V");
}
//#####################################################################
template class GEOMETRY_PARTICLES<VECTOR<float,1> >;
template class GEOMETRY_PARTICLES<VECTOR<float,2> >;
template class GEOMETRY_PARTICLES<VECTOR<float,3> >;
template class GEOMETRY_PARTICLES<VECTOR<double,1> >;
template class GEOMETRY_PARTICLES<VECTOR<double,2> >;
template class GEOMETRY_PARTICLES<VECTOR<double,3> >;
}
