//#####################################################################
// Copyright 2009, Nipun Kwatra, Michael Lentine.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Class GEOMETRY_PARTICLES
//#####################################################################
#ifndef __GEOMETRY_PARTICLES__
#define __GEOMETRY_PARTICLES__

#include <Core/Arrays/ARRAY.h>
#include <Core/Particles/PARTICLES.h>
namespace PhysBAM{

template<class TV>
class GEOMETRY_PARTICLES:public PARTICLES<TV>
{
    typedef typename TV::SCALAR T;
    typedef PARTICLES<TV> BASE;
public:
    using BASE::Remove_Array;using BASE::Add_Array;

    ARRAY_VIEW<TV> X,V;
    bool store_velocity;

    GEOMETRY_PARTICLES();
    GEOMETRY_PARTICLES(const GEOMETRY_PARTICLES&);
    virtual ~GEOMETRY_PARTICLES();

    void Store_Velocity(bool store=true);
//#####################################################################
};
}
#endif
