//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __CUBIC_SPLINE_INTERPOLATION__
#define __CUBIC_SPLINE_INTERPOLATION__

#include <Core/Interpolation/GENERAL_INTERPOLATION_CELL.h>
#include <Core/Interpolation/GENERAL_INTERPOLATION_FACE.h>
#include <Core/Interpolation/GENERAL_INTERPOLATION_NODE.h>
#include <Core/Interpolation/INTERPOLATION_UNIFORM_FORWARD.h>
namespace PhysBAM{

// C^1 continous
struct CUBIC_SPLINE_INTERPOLATION_STENCIL
{
    constexpr static int stencil_size=4;
    template<int a,int d,class T> static VECTOR<VECTOR<T,4>,1> Value(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,4>,1> Diff(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,4>,1> Hess(T t);
};

template<class TV,class T2>
using CUBIC_SPLINE_INTERPOLATION_NODE=GENERAL_INTERPOLATION_NODE<TV,T2,CUBIC_SPLINE_INTERPOLATION_STENCIL>;

template<class TV,class T2>
using CUBIC_SPLINE_INTERPOLATION_CELL=GENERAL_INTERPOLATION_CELL<TV,T2,CUBIC_SPLINE_INTERPOLATION_STENCIL>;

template<class TV,class T2,class T_FACE_ARRAY=ARRAY<T2,FACE_INDEX<TV::m> > >
using CUBIC_SPLINE_INTERPOLATION_FACE=GENERAL_INTERPOLATION_FACE<TV,T2,CUBIC_SPLINE_INTERPOLATION_STENCIL,false,T_FACE_ARRAY>;

template<class TV,class T2,class T_FACE_ARRAY>
struct CUBIC_SPLINE_INTERPOLATION_ALL:CUBIC_SPLINE_INTERPOLATION_NODE<TV,T2>,CUBIC_SPLINE_INTERPOLATION_CELL<TV,T2>,CUBIC_SPLINE_INTERPOLATION_FACE<TV,T2,T_FACE_ARRAY>
{
};

}
#endif
