//#####################################################################
// Copyright 2022, Ritoban Roy-Chowdhury, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __CURL_FREE_INTERPOLATION__
#define __CURL_FREE_INTERPOLATION__

#include <Core/Arrays/FACE_ARRAYS.h>
#include <Core/Interpolation/GENERAL_INTERPOLATION_AXIS_FACE.h>
namespace PhysBAM{


// interpolating polynomial
struct CURL_FREE_INTERPOLATION_STENCIL
{
    constexpr static int stencil_size=3;
    template<int a,int d,class T> static VECTOR<VECTOR<T,3+(a==d)>,1> Value(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,3+(a==d)>,1> Diff(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,3+(a==d)>,1> Hess(T t);
};

template<class TV,class T2,class T_FACE_ARRAY=ARRAY<T2,FACE_INDEX<TV::m> > >
using CURL_FREE_INTERPOLATION=GENERAL_INTERPOLATION_AXIS_FACE<TV,T2,CURL_FREE_INTERPOLATION_STENCIL,false,T_FACE_ARRAY>;

}
#endif
