//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __CURL_FREE_INTERPOLATION_4TH_ORDER__
#define __CURL_FREE_INTERPOLATION_4TH_ORDER__

#include <Core/Interpolation/GENERAL_INTERPOLATION_AXIS_FACE.h>
namespace PhysBAM{

template<int n>
struct CURL_FREE_INTERPOLATION_4TH_ORDER_STENCIL;

// interpolating polynomial
template<>
struct CURL_FREE_INTERPOLATION_4TH_ORDER_STENCIL<2>
{
    constexpr static int stencil_size=7;
    template<int a,int d,class T> static VECTOR<VECTOR<T,7+(a==d)>,2> Value(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,7+(a==d)>,2> Diff(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,7+(a==d)>,2> Hess(T t);
};

// interpolating polynomial
template<>
struct CURL_FREE_INTERPOLATION_4TH_ORDER_STENCIL<3>
{
    constexpr static int stencil_size=7;
    template<int a,int d,class T> static VECTOR<VECTOR<T,7+(a==d)>,3> Value(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,7+(a==d)>,3> Diff(T t);
    template<int a,int d,class T> static VECTOR<VECTOR<T,7+(a==d)>,3> Hess(T t);
};

template<class TV,class T2,class T_FACE_ARRAY=ARRAY<T2,FACE_INDEX<TV::m> > >
using CURL_FREE_INTERPOLATION_4TH_ORDER=GENERAL_INTERPOLATION_AXIS_FACE<TV,T2,CURL_FREE_INTERPOLATION_4TH_ORDER_STENCIL<TV::m>,false,T_FACE_ARRAY>;

}
#endif
