//#####################################################################
// Copyright 2003-2007, Ron Fedkiw, Geoffrey Irving, Frank Losasso, Andrew Selle.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Function integer_log
//#####################################################################
//
// base 2 logarithms of integers
//               
//#####################################################################
#ifndef __integer_log__
#define __integer_log__

namespace PhysBAM{
inline int integer_log(unsigned int v)
{
    int c=0;
    if(v&0xffff0000){v>>=16;c|=16;}
    if(v&0xff00){v>>=8;c|=8;}
    if(v&0xf0){v>>=4;c|=4;}
    if(v&0xc){v>>=2;c|=2;}
    if(v&2)c|=1;
    return c;
}
}
#endif
