//#####################################################################
// Copyright 2006, Geoffrey Irving, Eftychios Sifakis, Andrew Selle
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Read_Write/TYPED_STREAM.h>
#include <Core/Read_Write/FILE_UTILITIES.h>
#include <iostream>
#include <memory>
using namespace PhysBAM;
//#####################################################################
// Function Set
//#####################################################################
FILE_ISTREAM::
FILE_ISTREAM(const std::string& filename,bool binary)
    :raw(*Safe_Open_Input_Raw(filename,binary)),stream(raw,STREAM_TYPE::type_float)
{
    char c=raw.stream.peek();
    if(c==0 || c==1)
    {
        raw.stream.get();
        if(c==0) stream.type=STREAM_TYPE::type_float;
        else stream.type=STREAM_TYPE::type_double;
    }
    else
    {
        assert(c==EOF || isprint(c));
        stream.type=STREAM_TYPE::type_text;
    }
}
//#####################################################################
// Destructor
//#####################################################################
FILE_ISTREAM::
~FILE_ISTREAM()
{
    delete &raw.stream;
}
//#####################################################################
// Function Set
//#####################################################################
FILE_OSTREAM::
FILE_OSTREAM(STREAM_TYPE stream_type,const std::string& filename,
    bool binary,bool write_compressed_if_possible)
    :raw(*Safe_Open_Output_Raw(filename,binary,write_compressed_if_possible)),
    stream(raw,stream_type)
{
    if(stream.type!=STREAM_TYPE::type_text)
        raw.stream.put((char)(stream.type==STREAM_TYPE::type_double));
}
//#####################################################################
// Destructor
//#####################################################################
FILE_OSTREAM::
~FILE_OSTREAM()
{
    delete &raw.stream;
}
