//#####################################################################
// Copyright 2023, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Deformables/Constitutive_Models/PLASTICITY_MODEL.h>
#include <Core/Read_Write/READ_WRITE.h>
namespace PhysBAM{
//#####################################################################
// Constructor
//#####################################################################
template<class T,int d> PLASTICITY_MODEL<T,d>::
PLASTICITY_MODEL(const int elements)
{
    Fp_inverse.Exact_Resize(elements);
    Fp_inverse.Fill(SYMMETRIC_MATRIX<T,d>::Identity_Matrix());
}
//#####################################################################
// Function Read_State
//#####################################################################
template<class T,int d> void PLASTICITY_MODEL<T,d>::
Read_State(TYPED_ISTREAM& input)
{
    Read_Binary(input,Fp_inverse);
}
//#####################################################################
// Function Write_State
//#####################################################################
template<class T,int d> void PLASTICITY_MODEL<T,d>::
Write_State(TYPED_OSTREAM& output) const
{
    Write_Binary(output,Fp_inverse);
}
}
